## mingw-w64-kate-wakatime-1.5.3-1.src.tar.zst

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.31)

project(
  ktexteditor_wakatime
  VERSION 1.5.3
  DESCRIPTION "Kate plugin to interface with WakaTime."
  HOMEPAGE_URL https://tatsh.github.io/kate-wakatime/)

set(QT_MAJOR_VERSION "6")
set(QT_MIN_VERSION "6.5.0")
set(KF_DEP_VERSION "6.0.0")

set(CMAKE_AUTOMOC ON)
set(CMAKE_AUTORCC ON)
set(CMAKE_AUTOUIC ON)
set(CMAKE_CXX_STANDARD 20)
set(CMAKE_CXX_EXTENSIONS OFF)
set(CMAKE_CXX_STANDARD_REQUIRED TRUE)

add_definitions(-DTRANSLATION_DOMAIN=\"katewakatime\")

option(BUILD_DOCS_ONLY "Build documentation only." OFF)
option(BUILD_DOCS "Build documentation." OFF)
option(COVERAGE "Enable code coverage." OFF)

find_package(Doxygen)
if(Doxygen_FOUND AND (BUILD_DOCS OR BUILD_DOCS_ONLY))
  set(DOXYGEN_OUT ${CMAKE_CURRENT_BINARY_DIR}/Doxyfile)
  configure_file(${CMAKE_CURRENT_SOURCE_DIR}/Doxyfile.in ${DOXYGEN_OUT} @ONLY)
  add_custom_target(
    docs
    COMMAND ${DOXYGEN_EXECUTABLE} ${DOXYGEN_OUT}
    WORKING_DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR})
  install(
    DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}/docs/html
    DESTINATION ${CMAKE_INSTALL_DATAROOTDIR}/doc/${CMAKE_PROJECT_NAME}-${CMAKE_PROJECT_VERSION})
endif()

if(NOT BUILD_DOCS_ONLY)
  find_package(ECM ${KF_DEP_VERSION} REQUIRED NO_MODULE)
  list(APPEND CMAKE_MODULE_PATH ${ECM_MODULE_PATH})

  include(KDEInstallDirs6)
  include(KDECMakeSettings)
  include(ECMInstallIcons)
  include(KDECompilerSettings NO_POLICY_SCOPE)

  # Sane flags from Kate project.
  add_definitions(
    -DQT_NO_CAST_FROM_ASCII
    -DQT_NO_CAST_FROM_BYTEARRAY
    -DQT_NO_CAST_TO_ASCII
    -DQT_NO_SIGNALS_SLOTS_KEYWORDS
    -DQT_NO_URL_CAST_FROM_STRING
    -DQT_STRICT_ITERATORS
    -DQT_USE_FAST_OPERATOR_PLUS
    -DQT_USE_QSTRINGBUILDER
    -DVERSION=\"${CMAKE_PROJECT_VERSION}\")

  # Needed to find the moc file.
  include_directories(${CMAKE_CURRENT_BINARY_DIR})

  add_subdirectory(src)
endif()

=== src/CMakeLists.txt ===
find_package(KF6 ${KF_DEP_VERSION} REQUIRED COMPONENTS I18n TextEditor CoreAddons)

set(ktexteditor_wakatime_SRCS wakatimeconfig.cpp wakatimeconfig.h wakatimeplugin.cpp
                              wakatimeplugin.h wakatime.cpp wakatime.h)
ki18n_wrap_ui(ktexteditor_wakatime_SRCS configdialog.ui)
qt6_add_resources(ktexteditor_wakatime_SRCS plugin.qrc)
kcoreaddons_add_plugin(ktexteditor_wakatime INSTALL_NAMESPACE "kf6/ktexteditor" SOURCES
                       ${ktexteditor_wakatime_SRCS})
target_link_libraries(ktexteditor_wakatime KF6::I18n KF6::TextEditor KF6::CoreAddons)

set(WAKATIME_ICONS
    ${CMAKE_CURRENT_SOURCE_DIR}/../icons/16-apps-wakatime.png
    ${CMAKE_CURRENT_SOURCE_DIR}/../icons/22-apps-wakatime.png
    ${CMAKE_CURRENT_SOURCE_DIR}/../icons/32-apps-wakatime.png
    ${CMAKE_CURRENT_SOURCE_DIR}/../icons/48-apps-wakatime.png
    ${CMAKE_CURRENT_SOURCE_DIR}/../icons/64-apps-wakatime.png
    ${CMAKE_CURRENT_SOURCE_DIR}/../icons/128-apps-wakatime.png
    ${CMAKE_CURRENT_SOURCE_DIR}/../icons/256-apps-wakatime.png
    ${CMAKE_CURRENT_SOURCE_DIR}/../icons/512-apps-wakatime.png
    ${CMAKE_CURRENT_SOURCE_DIR}/../icons/sc-apps-wakatime.svg)

ecm_install_icons(ICONS ${WAKATIME_ICONS} DESTINATION ${KDE_INSTALL_ICONDIR} THEME hicolor)

if(BUILD_TESTING)
  enable_testing()
  add_subdirectory(autotests)
endif()

=== src/autotests/CMakeLists.txt ===
include(ECMMarkAsTest)

find_package(Qt6Test ${QT_MIN_VERSION} QUIET REQUIRED)

set(kate_wakatime_client_tests_SRCS clienttest.cpp ../wakatime.h ../wakatime.cpp)
set(kate_wakatime_config_tests_SRCS configtest.cpp ../wakatimeconfig.cpp ../wakatimeconfig.h)

function(create_test test_name test_srcs)
  add_executable(${test_name} ${test_srcs})
  target_compile_definitions(${test_name} PRIVATE TESTING)
  target_include_directories(${test_name} PRIVATE ${CMAKE_CURRENT_SOURCE_DIR}/..)
  if(COVERAGE AND CMAKE_COMPILER_IS_GNUCXX)
    target_compile_options(${test_name} PRIVATE --coverage)
    target_link_libraries(${test_name} PRIVATE gcov)
  endif()
  target_link_libraries(${test_name} PRIVATE Qt6::Test)
  add_test(NAME ${test_name} COMMAND ${test_name})
  ecm_mark_as_test(${test_name})
endfunction()

create_test(kate-wakatime-client-test "${kate_wakatime_client_tests_SRCS}")
create_test(kate-wakatime-config-test "${kate_wakatime_config_tests_SRCS}")
target_link_libraries(kate-wakatime-config-test PRIVATE KF6::I18n KF6::TextEditor)

=== PKGBUILD ===
# Maintainer: Andrew Udvare <audvare@gmail.com>

source "$(dirname ${BASH_SOURCE[0]})"/../mingw-w64-PKGBUILD-common/kde-frameworks
_realname=kate-wakatime
pkgbase="mingw-w64-${_realname}"
pkgname=("${MINGW_PACKAGE_PREFIX}-${_realname}")
pkgver=1.5.3
pkgrel=1
pkgdesc="Kate plugin to interface with WakaTime."
arch=('any')
mingw_arch=('ucrt64' 'clang64' 'clangarm64')
msys2_repository_url="https://github.com/Tatsh/kate-wakatime"
url="https://github.com/Tatsh/kate-wakatime"
license=('spdx:MIT')
depends=(
  "${MINGW_PACKAGE_PREFIX}-cc-libs"
  "${MINGW_PACKAGE_PREFIX}-kcompletion"
  "${MINGW_PACKAGE_PREFIX}-ki18n"
  "${MINGW_PACKAGE_PREFIX}-kparts"
  "${MINGW_PACKAGE_PREFIX}-ktexteditor"
  "${MINGW_PACKAGE_PREFIX}-kwidgetsaddons"
  "${MINGW_PACKAGE_PREFIX}-kxmlgui"
  "${MINGW_PACKAGE_PREFIX}-qt6-base"
  "${MINGW_PACKAGE_PREFIX}-wakatime"
)
makedepends=(
  "${MINGW_PACKAGE_PREFIX}-cc"
  "${MINGW_PACKAGE_PREFIX}-cmake"
  "${MINGW_PACKAGE_PREFIX}-extra-cmake-modules"
  "${MINGW_PACKAGE_PREFIX}-ninja"
  "${MINGW_PACKAGE_PREFIX}-qt6-declarative"
  "${MINGW_PACKAGE_PREFIX}-qt6-tools"
)
source=("https://github.com/Tatsh/${_realname}/archive/refs/tags/v${pkgver}.tar.gz")
sha256sums=('388ca44007dd909d222fe62567d34dced72724186d3103675df8f332f2875188')

build() {
  declare -a _extra_config
  if check_option "debug" "n"; then
    _extra_config+=("-DCMAKE_BUILD_TYPE=Release")
  else
    _extra_config+=("-DCMAKE_BUILD_TYPE=Debug")
  fi

  _kde_build_env
  MSYS2_ARG_CONV_EXCL="-DCMAKE_INSTALL_PREFIX=" \
    "${MINGW_PREFIX}"/bin/cmake.exe \
      -GNinja \
      -DCMAKE_INSTALL_PREFIX="${MINGW_PREFIX}" \
      "${_KDE_INSTALL_DIRS[@]}" \
      -DBUILD_TESTING=OFF \
      "${_extra_config[@]}" \
      -S "${_realname}-${pkgver}" \
      -B "build-${MSYSTEM}"

  "${MINGW_PREFIX}"/bin/cmake.exe --build "build-${MSYSTEM}"
}

package() {
  DESTDIR="${pkgdir}" "${MINGW_PREFIX}"/bin/cmake.exe --install "build-${MSYSTEM}"
}
